Bug 641423 - mingw32-gcc installs files both inside and outside the sysroot
mingw32-gcc installs files both inside and outside the sysroot
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: mingw32-gcc (Show other bugs)
19
All Linux
low Severity medium
: ---
: ---
Assigned To: Richard W.M. Jones
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks: 599567
  Show dependency treegraph
 
Reported: 2010-10-08 12:57 EDT by Paolo Bonzini
Modified: 2015-02-18 08:30 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-18 08:30:04 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
prototype patch (5.51 KB, patch)
2010-10-09 05:51 EDT, Paolo Bonzini
no flags Details | Diff

  None (edit)
Description Paolo Bonzini 2010-10-08 12:57:45 EDT
Description of problem:
mingw32-gcc is a strange hybrid package that installs files both inside and outside the sysroot.  The files in the sysroot should be separated in mingw32-libgcc.

Version-Release number of selected component (if applicable):
mingw32-gcc-4.4.2-2.fc13.x86_64

Additional info:
This makes the following packages depend incorrectly on mingw32-gcc:
* mingw32-gettext (directly)
* mingw32-pthreads (directly)
* mingw32-atk (indirectly)
* mingw32-glib2 (indirectly)
* mingw32-gtk2 (indirectly)
* mingw32-pango (indirectly)
Comment 1 Paolo Bonzini 2010-10-08 13:20:39 EDT
Actually, splitting into mingw32-libgcc and mingw32-libgomp would be even better, see bug 599567.
Comment 2 Paolo Bonzini 2010-10-09 05:51:45 EDT
Created attachment 452488 [details]
prototype patch
Comment 3 Paolo Bonzini 2010-10-11 08:37:03 EDT
koji scratch build from the patch at
https://koji.fedoraproject.org/koji/taskinfo?taskID=2527320
Comment 4 Erik van Pienbroek 2011-01-28 13:27:19 EST
The question with this patch is whether it is in line with the goals and packaging guidelines of the Fedora MinGW SIG. The mission mentioned at https://fedoraproject.org/wiki/MinGW is:

  The Fedora MinGW project's mission is to provide an excellent development
  environment for Fedora users who wish to cross-compile their programs to
  run on Windows, minimizing the need to use Windows at all.

In other words, it is targeted at developers. With your patch you're splitting the runtime and development parts apart. As all current mingw32 packages have both runtime and development parts in the same RPM (thus no -devel subpackages) I don't see why we should divert from this for the gcc package.
Comment 5 Paolo Bonzini 2011-01-29 09:26:33 EST
I believe this lets other packages express their dependencies better.  In particular, there is no need for libraries to depend on a compiler: they only need the runtime libraries of the compiler.  gtk+ and SDL should not be different in this respect: either both should depend on a compiler or none should.  The fact that gtk+ indirectly uses the pthreads emulation library doesn't change anything.  

In short, Fedora devel packages never require a compiler, but a few mingw32 packages do.  For this reason, I believe the fact that MinGW packages are always -devel packages is irrelevant.

As an aside, I don't believe the MinGW SIG mission totally excludes the presence of -devel package.  Separating them would still be very useful, because it would distinguish files that need to be deployed on Windows, and files that are for development only.  This is on the hypothesis that those Fedora users also need to distribute their applications after having cross-compiled them. :)

In order to automate the distribution task, I'm leveraging RPM package dependencies to list what needs to be deployed on Windows, and then make self-contained application installers.  Having separate -devel packages would be nicer for me, because I would have an easy way to know what has to be deployed on Windows, and what is for development only.  However, I understand that it would be a big change and I can live without it.

This leads back to the rationale behind reporting this bug.  If the cross-compiled product depends on files outside the sysroot, that should be a fatal error, because this would be a dependency on something available on Linux only.  Currently I have to ignore them and eliminate a possibly useful diagnostic, so I opened this bug.
Comment 6 Bug Zapper 2011-05-31 07:43:20 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 7 Bug Zapper 2011-06-28 07:49:43 EDT
Fedora 13 changed to end-of-life (EOL) status on 2011-06-25. Fedora 13 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 8 Fedora End Of Life 2013-04-03 16:14:52 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 9 Fedora End Of Life 2015-01-09 16:46:03 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 10 Fedora End Of Life 2015-02-18 08:30:04 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.